/* ClipboardManager.c generated by valac 0.55.1, the Vala compiler
 * generated from ClipboardManager.vala, do not modify */

/*
 *  NOTE: This is an adaptation of the ClipboardManager class from elementary Files project.
 *
 *  Copyright (c) 2016 elementary LLC (http://launchpad.net/elementary)
 *
 *  Based on C code imported from Thunar
 *  Copyright (c) 2005-2006 Benedikt Meurer <benny@xfce.org>
 *  Copyright (c) 2009 Jannis Pohlmann <jannis@xfce.org>*
 *  Copyright (c) 2017-2019 José Amuedo (https://github.com/spheras)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Author(s):  Jeremy Wootten <jeremy@elementaryos.org>
 *
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY _ ("There is nothing on the clipboard to paste")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER (desktop_folder_clipboard_clipboard_manager_get_type ())
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManagerClass))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManagerClass))

typedef struct _DesktopFolderClipboardClipboardManager DesktopFolderClipboardClipboardManager;
typedef struct _DesktopFolderClipboardClipboardManagerClass DesktopFolderClipboardClipboardManagerClass;
typedef struct _DesktopFolderClipboardClipboardManagerPrivate DesktopFolderClipboardClipboardManagerPrivate;

#define DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE (desktop_folder_clipboard_clipboard_file_get_type ())
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, DesktopFolderClipboardClipboardFile))
#define DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE))
#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_FILE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, DesktopFolderClipboardClipboardFileIface))

typedef struct _DesktopFolderClipboardClipboardFile DesktopFolderClipboardClipboardFile;
typedef struct _DesktopFolderClipboardClipboardFileIface DesktopFolderClipboardClipboardFileIface;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW (desktop_folder_dragn_drop_dnd_view_get_type ())
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndView))
#define DESKTOP_FOLDER_DRAGN_DROP_IS_DND_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW))
#define DESKTOP_FOLDER_DRAGN_DROP_DND_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DESKTOP_FOLDER_DRAGN_DROP_TYPE_DND_VIEW, DesktopFolderDragnDropDndViewIface))

typedef struct _DesktopFolderDragnDropDndView DesktopFolderDragnDropDndView;
typedef struct _DesktopFolderDragnDropDndViewIface DesktopFolderDragnDropDndViewIface;
enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_0_PROPERTY,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_PROPERTIES];
typedef enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING
} DesktopFolderClipboardClipboardManagerClipboardTarget;

#define DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_TYPE_CLIPBOARD_TARGET (desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef enum  {
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_STRING,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_XDND_DIRECT_SAVE0,
	DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_NETSCAPE_URL
} DesktopFolderDragnDropTargetType;

#define DESKTOP_FOLDER_DRAGN_DROP_TYPE_TARGET_TYPE (desktop_folder_dragn_drop_target_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL,
	DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_SIGNALS
};
static guint desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_NUM_SIGNALS] = {0};

struct _DesktopFolderClipboardClipboardManager {
	GObject parent_instance;
	DesktopFolderClipboardClipboardManagerPrivate * priv;
};

struct _DesktopFolderClipboardClipboardManagerClass {
	GObjectClass parent_class;
};

struct _DesktopFolderDragnDropDndViewIface {
	GTypeInterface parent_iface;
	GtkWidget* (*get_widget) (DesktopFolderDragnDropDndView* self);
	GtkApplicationWindow* (*get_application_window) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file) (DesktopFolderDragnDropDndView* self);
	GtkImage* (*get_image) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_file_at) (DesktopFolderDragnDropDndView* self, gint x, gint y);
	gboolean (*is_folder) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_writable) (DesktopFolderDragnDropDndView* self);
	GFile* (*get_target_location) (DesktopFolderDragnDropDndView* self);
	gboolean (*is_recent_uri_scheme) (DesktopFolderDragnDropDndView* self);
	gchar* (*get_display_target_uri) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_end) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_motion) (DesktopFolderDragnDropDndView* self);
	void (*on_drag_leave) (DesktopFolderDragnDropDndView* self);
	DesktopFolderDragnDropDndView** (*get_all_selected_views) (DesktopFolderDragnDropDndView* self, gint* result_length1);
};

struct _DesktopFolderClipboardClipboardFileIface {
	GTypeInterface parent_iface;
};

struct _DesktopFolderClipboardClipboardManagerPrivate {
	GtkClipboard* clipboard;
	GList* files;
	gboolean files_cutted;
	gboolean _can_paste;
};

struct _Block3Data {
	int _ref_count_;
	DesktopFolderClipboardClipboardManager* self;
	GFile* target_file;
	GtkWidget* widget;
	GCallback new_files_callback;
};

static gint DesktopFolderClipboardClipboardManager_private_offset;
static gpointer desktop_folder_clipboard_clipboard_manager_parent_class = NULL;
static GQuark desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark;
static GQuark desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark = 0U;
static GdkAtom desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files;
static GdkAtom desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files = (GdkAtom) 0U;

VALA_EXTERN GType desktop_folder_clipboard_clipboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DesktopFolderClipboardClipboardManager, g_object_unref)
VALA_EXTERN GType desktop_folder_dragn_drop_dnd_view_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType desktop_folder_clipboard_clipboard_file_get_type (void) G_GNUC_CONST ;
static void desktop_folder_clipboard_clipboard_manager_release_pending_files (DesktopFolderClipboardClipboardManager* self);
static void desktop_folder_clipboard_clipboard_manager_owner_changed (DesktopFolderClipboardClipboardManager* self,
                                                               GdkEvent* owner_change_event);
static void _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                                           GdkEventOwnerChange* event,
                                                                                           gpointer self);
static GType desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_new (GtkClipboard* _clipboard);
static DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_construct (GType object_type,
                                                                                              GtkClipboard* _clipboard);
VALA_EXTERN DesktopFolderClipboardClipboardManager* desktop_folder_clipboard_clipboard_manager_get_for_display (GdkDisplay* display);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_has_cutted_file (DesktopFolderClipboardClipboardManager* self,
                                                                     DesktopFolderClipboardClipboardFile* file);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_has_file (DesktopFolderClipboardClipboardManager* self,
                                                              DesktopFolderClipboardClipboardFile* file);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_copy_files (DesktopFolderClipboardClipboardManager* self,
                                                            GList* files);
static void desktop_folder_clipboard_clipboard_manager_transfer_files (DesktopFolderClipboardClipboardManager* self,
                                                                gboolean copy,
                                                                GList* files_for_transfer);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_cut_files (DesktopFolderClipboardClipboardManager* self,
                                                           GList* files);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_paste_files (DesktopFolderClipboardClipboardManager* self,
                                                             GFile* target_file,
                                                             GtkWidget* widget,
                                                             GCallback new_files_callback);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda26_ (Block3Data* _data3_,
                  GtkClipboard* cb,
                  GtkSelectionData* sd);
static void desktop_folder_clipboard_clipboard_manager_contents_received (DesktopFolderClipboardClipboardManager* self,
                                                                   GtkSelectionData* sd,
                                                                   GFile* target_file,
                                                                   GtkWidget* widget,
                                                                   GCallback new_files_callback);
static void ___lambda26__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                               GtkSelectionData* selection_data,
                                               gpointer self);
VALA_EXTERN gboolean desktop_folder_dragn_drop_dnd_handler_selection_data_is_uri_list (GtkSelectionData* selection_data,
                                                                           guint info,
                                                                           gchar** text);
VALA_EXTERN GType desktop_folder_dragn_drop_target_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void desktop_folder_util_show_error_dialog (const gchar* title,
                                            const gchar* message);
VALA_EXTERN GList* desktop_folder_dragn_drop_util_list_new_from_string (const gchar* str);
VALA_EXTERN void desktop_folder_dragn_drop_util_copy_move (GList* files,
                                               GFile* target_dir,
                                               GdkDragAction action,
                                               GtkWidget* parent_view,
                                               GCallback done_callback,
                                               GtkWidget* done_callback_data);
static void __lambda25_ (DesktopFolderClipboardClipboardManager* self,
                  GtkClipboard* cb,
                  GtkSelectionData* sd);
static void desktop_folder_clipboard_clipboard_manager_set_can_paste (DesktopFolderClipboardClipboardManager* self,
                                                               gboolean value);
static void ___lambda25__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                               GtkSelectionData* selection_data,
                                               gpointer self);
static void desktop_folder_clipboard_clipboard_manager_on_file_destroyed (DesktopFolderClipboardClipboardManager* self,
                                                                   DesktopFolderClipboardClipboardFile* file);
static void _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete (DesktopFolderClipboardClipboardFile* _sender,
                                                                                                                      gpointer self);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_get_callback (GtkClipboard* cb,
                                                              GtkSelectionData* sd,
                                                              guint target_info,
                                                              void* parent);
static void _desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                                      GtkSelectionData* selection_data,
                                                                                      guint info,
                                                                                      void* user_data_or_owner);
VALA_EXTERN void desktop_folder_clipboard_clipboard_manager_clear_callback (GtkClipboard* cb,
                                                                void* parent);
static void _desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                                          void* user_data_or_owner);
VALA_EXTERN void desktop_folder_dragn_drop_dnd_handler_set_selection_data_from_file_list (GtkSelectionData* selection_data,
                                                                              GList* file_list,
                                                                              const gchar* prefix);
static gchar* desktop_folder_clipboard_clipboard_manager_file_list_to_string (DesktopFolderClipboardClipboardManager* self);
VALA_EXTERN GFile* desktop_folder_dragn_drop_dnd_view_get_target_location (DesktopFolderDragnDropDndView* self);
VALA_EXTERN gboolean desktop_folder_clipboard_clipboard_manager_get_can_paste (DesktopFolderClipboardClipboardManager* self);
static void desktop_folder_clipboard_clipboard_manager_finalize (GObject * obj);
static GType desktop_folder_clipboard_clipboard_manager_get_type_once (void);
static void _vala_desktop_folder_clipboard_clipboard_manager_get_property (GObject * object,
                                                                    guint property_id,
                                                                    GValue * value,
                                                                    GParamSpec * pspec);
static void _vala_desktop_folder_clipboard_clipboard_manager_set_property (GObject * object,
                                                                    guint property_id,
                                                                    const GValue * value,
                                                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GtkTargetEntry DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets[2] = {{"x-special/gnome-copied-files", (guint) 0, (guint) DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES}, {"UTF8_STRING", (guint) 0, (guint) DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING}};

static inline gpointer
desktop_folder_clipboard_clipboard_manager_get_instance_private (DesktopFolderClipboardClipboardManager* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopFolderClipboardClipboardManager_private_offset);
}

static void
_desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                                      GdkEventOwnerChange* event,
                                                                                      gpointer self)
{
	desktop_folder_clipboard_clipboard_manager_owner_changed ((DesktopFolderClipboardClipboardManager*) self, event);
}

static GType
desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES, "DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES", "gnome-copied-files"}, {DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING, "DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING", "utf8-string"}, {0, NULL, NULL}};
	GType desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
	desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id = g_enum_register_static ("DesktopFolderClipboardClipboardManagerClipboardTarget", values);
	return desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
}

static GType
desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type (void)
{
	static volatile gsize desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once)) {
		GType desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id;
		desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id = desktop_folder_clipboard_clipboard_manager_clipboard_target_get_type_once ();
		g_once_init_leave (&desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once, desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id);
	}
	return desktop_folder_clipboard_clipboard_manager_clipboard_target_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_construct (GType object_type,
                                                      GtkClipboard* _clipboard)
{
	DesktopFolderClipboardClipboardManager * self = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	DesktopFolderClipboardClipboardManager* _tmp2_;
	GtkClipboard* _tmp3_;
	g_return_val_if_fail (_clipboard != NULL, NULL);
	self = (DesktopFolderClipboardClipboardManager*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (_clipboard);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->clipboard = _tmp0_;
	_tmp1_ = self->priv->clipboard;
	_tmp2_ = _g_object_ref0 (self);
	g_object_set_qdata_full ((GObject*) _tmp1_, desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark, _tmp2_, g_object_unref);
	_tmp3_ = self->priv->clipboard;
	g_signal_connect_object (_tmp3_, "owner-change", (GCallback) _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change, self, 0);
	return self;
}

static DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_new (GtkClipboard* _clipboard)
{
	return desktop_folder_clipboard_clipboard_manager_construct (DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, _clipboard);
}

DesktopFolderClipboardClipboardManager*
desktop_folder_clipboard_clipboard_manager_get_for_display (GdkDisplay* display)
{
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	DesktopFolderClipboardClipboardManager* manager = NULL;
	GtkClipboard* _tmp2_;
	gconstpointer _tmp3_;
	DesktopFolderClipboardClipboardManager* _tmp4_;
	DesktopFolderClipboardClipboardManager* _tmp5_;
	DesktopFolderClipboardClipboardManager* result;
	if (display == NULL) {
		g_critical ("ClipboardManager.vala:63: ClipboardManager cannot find display");
		g_assert_not_reached ();
	}
	_tmp0_ = gtk_clipboard_get_for_display (display, GDK_SELECTION_CLIPBOARD);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	clipboard = _tmp1_;
	_tmp2_ = clipboard;
	_tmp3_ = g_object_get_qdata ((GObject*) _tmp2_, desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark);
	_tmp4_ = _g_object_ref0 ((DesktopFolderClipboardClipboardManager*) _tmp3_);
	manager = _tmp4_;
	_tmp5_ = manager;
	if (_tmp5_ != NULL) {
		result = manager;
		_g_object_unref0 (clipboard);
		return result;
	} else {
		GtkClipboard* _tmp6_;
		DesktopFolderClipboardClipboardManager* _tmp7_;
		_tmp6_ = clipboard;
		_tmp7_ = desktop_folder_clipboard_clipboard_manager_new (_tmp6_);
		result = _tmp7_;
		_g_object_unref0 (manager);
		_g_object_unref0 (clipboard);
		return result;
	}
}

/** If @file is null, returns whether there are ANY cut files
         * otherwise whether @file is amongst the cut files
         **/
gboolean
desktop_folder_clipboard_clipboard_manager_has_cutted_file (DesktopFolderClipboardClipboardManager* self,
                                                            DesktopFolderClipboardClipboardFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->files_cutted) {
		gboolean _tmp1_ = FALSE;
		if (file == NULL) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = desktop_folder_clipboard_clipboard_manager_has_file (self, file);
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gboolean
desktop_folder_clipboard_clipboard_manager_has_file (DesktopFolderClipboardClipboardManager* self,
                                                     DesktopFolderClipboardClipboardFile* file)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp1_ = self->priv->files;
	if (_tmp1_ != NULL) {
		GList* _tmp2_;
		GList* _tmp3_;
		_tmp2_ = self->priv->files;
		_tmp3_ = g_list_find (_tmp2_, file);
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
desktop_folder_clipboard_clipboard_manager_copy_files (DesktopFolderClipboardClipboardManager* self,
                                                       GList* files)
{
	g_return_if_fail (self != NULL);
	desktop_folder_clipboard_clipboard_manager_transfer_files (self, TRUE, files);
}

void
desktop_folder_clipboard_clipboard_manager_cut_files (DesktopFolderClipboardClipboardManager* self,
                                                      GList* files)
{
	g_return_if_fail (self != NULL);
	desktop_folder_clipboard_clipboard_manager_transfer_files (self, FALSE, files);
}

/**
         * @target_file        : the #GFile of the folder to which the contents on the clipboard
         *                       should be pasted.
         * @widget             : a #GtkWidget, on which to perform the paste or %NULL if no widget is
         *                       known.
         * @new_files_callback : a #GCallback to connect to the job's "new-files" signal,
         *                       which will be emitted when the job finishes with the
         *                       list of #GFile<!---->s created by the job, or
         *                       %NULL if you're not interested in the signal.
         *
         * Pastes the contents from the clipboard to the directory
         * referenced by @target_file.
         **/
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		DesktopFolderClipboardClipboardManager* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->target_file);
		_g_object_unref0 (_data3_->widget);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda26_ (Block3Data* _data3_,
             GtkClipboard* cb,
             GtkSelectionData* sd)
{
	DesktopFolderClipboardClipboardManager* self;
	self = _data3_->self;
	g_return_if_fail (cb != NULL);
	g_return_if_fail (sd != NULL);
	desktop_folder_clipboard_clipboard_manager_contents_received (self, sd, _data3_->target_file, _data3_->widget, _data3_->new_files_callback);
}

static void
___lambda26__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                          GtkSelectionData* selection_data,
                                          gpointer self)
{
	__lambda26_ (self, clipboard, selection_data);
	block3_data_unref (self);
}

void
desktop_folder_clipboard_clipboard_manager_paste_files (DesktopFolderClipboardClipboardManager* self,
                                                        GFile* target_file,
                                                        GtkWidget* widget,
                                                        GCallback new_files_callback)
{
	Block3Data* _data3_;
	GFile* _tmp0_;
	GtkWidget* _tmp1_;
	GtkClipboard* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target_file != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (target_file);
	_g_object_unref0 (_data3_->target_file);
	_data3_->target_file = _tmp0_;
	_tmp1_ = _g_object_ref0 (widget);
	_g_object_unref0 (_data3_->widget);
	_data3_->widget = _tmp1_;
	_data3_->new_files_callback = new_files_callback;
	_tmp2_ = self->priv->clipboard;
	gtk_clipboard_request_contents (_tmp2_, desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files, ___lambda26__gtk_clipboard_received_func, block3_data_ref (_data3_));
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static void
desktop_folder_clipboard_clipboard_manager_contents_received (DesktopFolderClipboardClipboardManager* self,
                                                              GtkSelectionData* sd,
                                                              GFile* target_file,
                                                              GtkWidget* widget,
                                                              GCallback new_files_callback)
{
	gchar* text = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	GdkDragAction action = 0U;
	const gchar* _tmp3_;
	GList* file_list = NULL;
	const gchar* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GtkClipboard* _tmp14_;
	GdkDisplay* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sd != NULL);
	g_return_if_fail (target_file != NULL);
	_tmp1_ = desktop_folder_dragn_drop_dnd_handler_selection_data_is_uri_list (sd, (guint) DESKTOP_FOLDER_DRAGN_DROP_TARGET_TYPE_TEXT_URI_LIST, &_tmp0_);
	_g_free0 (text);
	text = _tmp0_;
	if (!_tmp1_) {
		g_warning ("ClipboardManager.vala:144: Selection data not uri_list in Marlin.Clipb" \
"oardManager contents_received");
		_g_free0 (text);
		return;
	}
	_tmp2_ = text;
	if (_tmp2_ == NULL) {
		g_warning ("ClipboardManager.vala:149: Empty selection data in Marlin.ClipboardMan" \
"ager contents_received");
		desktop_folder_util_show_error_dialog (NULL, DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY);
		_g_free0 (text);
		return;
	}
	action = 0;
	_tmp3_ = text;
	if (g_str_has_prefix (_tmp3_, "copy")) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		action = GDK_ACTION_COPY;
		_tmp4_ = text;
		_tmp5_ = string_substring (_tmp4_, (glong) 4, (glong) -1);
		_g_free0 (text);
		text = _tmp5_;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = text;
		if (g_str_has_prefix (_tmp6_, "cut")) {
			const gchar* _tmp7_;
			gchar* _tmp8_;
			action = GDK_ACTION_MOVE;
			_tmp7_ = text;
			_tmp8_ = string_substring (_tmp7_, (glong) 3, (glong) -1);
			_g_free0 (text);
			text = _tmp8_;
		} else {
			g_warning ("ClipboardManager.vala:162: Invalid selection data in Marlin.ClipboardM" \
"anager contents_received");
			desktop_folder_util_show_error_dialog (NULL, DESKTOP_FOLDER_LANG_CLIPBOARD_EMPTY);
			_g_free0 (text);
			return;
		}
	}
	_tmp9_ = text;
	_tmp10_ = desktop_folder_dragn_drop_util_list_new_from_string (_tmp9_);
	file_list = _tmp10_;
	_tmp11_ = file_list;
	if (_tmp11_ != NULL) {
		GList* _tmp12_;
		_tmp12_ = file_list;
		desktop_folder_dragn_drop_util_copy_move (_tmp12_, target_file, action, widget, new_files_callback, widget);
	}
	if (action != GDK_ACTION_COPY) {
		GtkClipboard* _tmp13_;
		_tmp13_ = self->priv->clipboard;
		gtk_clipboard_clear (_tmp13_);
	}
	_tmp14_ = self->priv->clipboard;
	_tmp15_ = gtk_clipboard_get_display (_tmp14_);
	if (!gdk_display_supports_selection_notification (_tmp15_)) {
		desktop_folder_clipboard_clipboard_manager_owner_changed (self, NULL);
	}
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
	_g_free0 (text);
}

static void
__lambda25_ (DesktopFolderClipboardClipboardManager* self,
             GtkClipboard* cb,
             GtkSelectionData* sd)
{
	GdkAtom* targets = NULL;
	gint targets_length1;
	gint _targets_size_;
	GdkAtom* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkAtom* _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (cb != NULL);
	g_return_if_fail (sd != NULL);
	desktop_folder_clipboard_clipboard_manager_set_can_paste (self, FALSE);
	targets = NULL;
	targets_length1 = 0;
	_targets_size_ = targets_length1;
	gtk_selection_data_get_targets (sd, &_tmp0_, &_tmp1_);
	targets = (g_free (targets), NULL);
	targets = _tmp0_;
	targets_length1 = _tmp1_;
	_targets_size_ = targets_length1;
	_tmp2_ = targets;
	_tmp2__length1 = targets_length1;
	{
		GdkAtom* target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
		target_collection = _tmp2_;
		target_collection_length1 = _tmp2__length1;
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
			GdkAtom target = (GdkAtom) 0U;
			target = target_collection[target_it];
			{
				if (target == desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files) {
					desktop_folder_clipboard_clipboard_manager_set_can_paste (self, TRUE);
					break;
				}
			}
		}
	}
	g_signal_emit (self, desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL], 0);
	g_object_notify ((GObject*) self, "can-paste");
	targets = (g_free (targets), NULL);
}

static void
___lambda25__gtk_clipboard_received_func (GtkClipboard* clipboard,
                                          GtkSelectionData* selection_data,
                                          gpointer self)
{
	__lambda25_ ((DesktopFolderClipboardClipboardManager*) self, clipboard, selection_data);
	g_object_unref (self);
}

static void
desktop_folder_clipboard_clipboard_manager_owner_changed (DesktopFolderClipboardClipboardManager* self,
                                                          GdkEvent* owner_change_event)
{
	GtkClipboard* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clipboard;
	gtk_clipboard_request_contents (_tmp0_, gdk_atom_intern_static_string ("TARGETS"), ___lambda25__gtk_clipboard_received_func, g_object_ref (self));
}

/**
         * Sets the clipboard to contain @files_for_transfer and marks them to be copied
         * or moved according to @copy when the user pastes from the clipboard.
         **/
static void
_desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete (DesktopFolderClipboardClipboardFile* _sender,
                                                                                                                 gpointer self)
{
	desktop_folder_clipboard_clipboard_manager_on_file_destroyed ((DesktopFolderClipboardClipboardManager*) self, _sender);
}

static void
_desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func (GtkClipboard* clipboard,
                                                                                 GtkSelectionData* selection_data,
                                                                                 guint info,
                                                                                 void* user_data_or_owner)
{
	desktop_folder_clipboard_clipboard_manager_get_callback (clipboard, selection_data, info, user_data_or_owner);
}

static void
_desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func (GtkClipboard* clipboard,
                                                                                     void* user_data_or_owner)
{
	desktop_folder_clipboard_clipboard_manager_clear_callback (clipboard, user_data_or_owner);
}

static void
desktop_folder_clipboard_clipboard_manager_transfer_files (DesktopFolderClipboardClipboardManager* self,
                                                           gboolean copy,
                                                           GList* files_for_transfer)
{
	GtkClipboard* _tmp4_;
	GtkClipboard* _tmp5_;
	GdkDisplay* _tmp6_;
	g_return_if_fail (self != NULL);
	desktop_folder_clipboard_clipboard_manager_release_pending_files (self);
	self->priv->files_cutted = !copy;
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = files_for_transfer;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			DesktopFolderClipboardClipboardFile* _tmp0_;
			DesktopFolderClipboardClipboardFile* file = NULL;
			_tmp0_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
			file = _tmp0_;
			{
				DesktopFolderClipboardClipboardFile* _tmp1_;
				DesktopFolderClipboardClipboardFile* _tmp2_;
				DesktopFolderClipboardClipboardFile* _tmp3_;
				_tmp1_ = file;
				_tmp2_ = _g_object_ref0 (_tmp1_);
				self->priv->files = g_list_prepend (self->priv->files, _tmp2_);
				_tmp3_ = file;
				g_signal_connect_object (_tmp3_, "on-delete", (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self, 0);
				_g_object_unref0 (file);
			}
		}
	}
	_tmp4_ = self->priv->clipboard;
	gtk_clipboard_set_with_owner (_tmp4_, DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets, (guint) G_N_ELEMENTS (DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_clipboard_targets), _desktop_folder_clipboard_clipboard_manager_get_callback_gtk_clipboard_get_func, _desktop_folder_clipboard_clipboard_manager_clear_callback_gtk_clipboard_clear_func, (GObject*) self);
	_tmp5_ = self->priv->clipboard;
	_tmp6_ = gtk_clipboard_get_display (_tmp5_);
	if (!gdk_display_supports_selection_notification (_tmp6_)) {
		desktop_folder_clipboard_clipboard_manager_owner_changed (self, NULL);
	}
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
	l = self;
	while (TRUE) {
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		_tmp0_ = l;
		if (!(_tmp0_ != NULL)) {
			break;
		}
		_tmp1_ = l;
		_tmp2_ = ((GList*) _tmp1_)->data;
		if (_tmp2_ != data) {
			GList* _tmp3_;
			GList* _tmp4_;
			_tmp3_ = l;
			_tmp4_ = ((GList*) _tmp3_)->next;
			l = _tmp4_;
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
			_tmp5_ = l;
			_tmp6_ = ((GList*) _tmp5_)->data;
			func (_tmp6_);
			_tmp7_ = l;
			self = g_list_delete_link (self, (GList*) _tmp7_);
			break;
		}
	}
	result = self;
	return result;
}

static void
desktop_folder_clipboard_clipboard_manager_on_file_destroyed (DesktopFolderClipboardClipboardManager* self,
                                                              DesktopFolderClipboardClipboardFile* file)
{
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_signal_parse_name ("on-delete", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (file, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self);
	self->priv->files = vala_g_list_remove_full (self->priv->files, file, _g_object_unref0_);
}

void
desktop_folder_clipboard_clipboard_manager_get_callback (GtkClipboard* cb,
                                                         GtkSelectionData* sd,
                                                         guint target_info,
                                                         void* parent)
{
	DesktopFolderClipboardClipboardManager* manager = NULL;
	DesktopFolderClipboardClipboardManager* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DesktopFolderClipboardClipboardManager* _tmp2_;
	g_return_if_fail (cb != NULL);
	g_return_if_fail (sd != NULL);
	_tmp0_ = _g_object_ref0 (DESKTOP_FOLDER_CLIPBOARD_IS_CLIPBOARD_MANAGER (parent) ? ((DesktopFolderClipboardClipboardManager*) parent) : NULL);
	manager = _tmp0_;
	_tmp2_ = manager;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		DesktopFolderClipboardClipboardManager* _tmp3_;
		GtkClipboard* _tmp4_;
		_tmp3_ = manager;
		_tmp4_ = _tmp3_->priv->clipboard;
		_tmp1_ = _tmp4_ != cb;
	}
	if (_tmp1_) {
		_g_object_unref0 (manager);
		return;
	}
	switch (target_info) {
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_GNOME_COPIED_FILES:
		{
			const gchar* _tmp5_ = NULL;
			DesktopFolderClipboardClipboardManager* _tmp6_;
			gchar* prefix = NULL;
			gchar* _tmp7_;
			DesktopFolderClipboardClipboardManager* _tmp8_;
			GList* _tmp9_;
			const gchar* _tmp10_;
			_tmp6_ = manager;
			if (_tmp6_->priv->files_cutted) {
				_tmp5_ = "cut";
			} else {
				_tmp5_ = "copy";
			}
			_tmp7_ = g_strdup (_tmp5_);
			prefix = _tmp7_;
			_tmp8_ = manager;
			_tmp9_ = _tmp8_->priv->files;
			_tmp10_ = prefix;
			desktop_folder_dragn_drop_dnd_handler_set_selection_data_from_file_list (sd, _tmp9_, _tmp10_);
			_g_free0 (prefix);
			break;
		}
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CLIPBOARD_TARGET_UTF8_STRING:
		{
			gchar* str = NULL;
			DesktopFolderClipboardClipboardManager* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			_tmp11_ = manager;
			_tmp12_ = desktop_folder_clipboard_clipboard_manager_file_list_to_string (_tmp11_);
			str = _tmp12_;
			_tmp13_ = str;
			_tmp14_ = str;
			_tmp15_ = strlen (_tmp14_);
			_tmp16_ = _tmp15_;
			gtk_selection_data_set_text (sd, _tmp13_, _tmp16_);
			_g_free0 (str);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_g_object_unref0 (manager);
}

static gchar*
desktop_folder_clipboard_clipboard_manager_file_list_to_string (DesktopFolderClipboardClipboardManager* self)
{
	GString* sb = NULL;
	GString* _tmp0_;
	guint count = 0U;
	guint file_count = 0U;
	GList* _tmp1_;
	GList* _tmp2_;
	GString* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	count = (guint) 0;
	_tmp1_ = self->priv->files;
	file_count = g_list_length (_tmp1_);
	_tmp2_ = self->priv->files;
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp2_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			DesktopFolderClipboardClipboardFile* _tmp3_;
			DesktopFolderClipboardClipboardFile* file = NULL;
			_tmp3_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
			file = _tmp3_;
			{
				GFile* loc = NULL;
				DesktopFolderClipboardClipboardFile* _tmp4_;
				GFile* _tmp5_;
				gchar* pn = NULL;
				GFile* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint _tmp16_;
				_tmp4_ = file;
				_tmp5_ = desktop_folder_dragn_drop_dnd_view_get_target_location ((DesktopFolderDragnDropDndView*) _tmp4_);
				loc = _tmp5_;
				_tmp6_ = loc;
				_tmp7_ = g_file_get_parse_name (_tmp6_);
				pn = _tmp7_;
				_tmp8_ = pn;
				if (_tmp8_ != NULL) {
					GString* _tmp9_;
					const gchar* _tmp10_;
					_tmp9_ = sb;
					_tmp10_ = pn;
					g_string_append (_tmp9_, _tmp10_);
				} else {
					GString* _tmp11_;
					GFile* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					_tmp11_ = sb;
					_tmp12_ = loc;
					_tmp13_ = g_file_get_uri (_tmp12_);
					_tmp14_ = _tmp13_;
					g_string_append (_tmp11_, _tmp14_);
					_g_free0 (_tmp14_);
				}
				if (count < file_count) {
					GString* _tmp15_;
					_tmp15_ = sb;
					g_string_append (_tmp15_, "\n");
				}
				_tmp16_ = count;
				count = _tmp16_ + 1;
				_g_free0 (pn);
				_g_object_unref0 (loc);
				_g_object_unref0 (file);
			}
		}
	}
	_tmp17_ = sb;
	_tmp18_ = _tmp17_->str;
	_tmp19_ = g_strdup (_tmp18_);
	result = _tmp19_;
	_g_string_free0 (sb);
	return result;
}

void
desktop_folder_clipboard_clipboard_manager_clear_callback (GtkClipboard* cb,
                                                           void* parent)
{
	DesktopFolderClipboardClipboardManager* manager = NULL;
	DesktopFolderClipboardClipboardManager* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DesktopFolderClipboardClipboardManager* _tmp2_;
	DesktopFolderClipboardClipboardManager* _tmp5_;
	g_return_if_fail (cb != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager));
	manager = _tmp0_;
	_tmp2_ = manager;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		DesktopFolderClipboardClipboardManager* _tmp3_;
		GtkClipboard* _tmp4_;
		_tmp3_ = manager;
		_tmp4_ = _tmp3_->priv->clipboard;
		_tmp1_ = _tmp4_ != cb;
	}
	if (_tmp1_) {
		_g_object_unref0 (manager);
		return;
	}
	_tmp5_ = manager;
	desktop_folder_clipboard_clipboard_manager_release_pending_files (_tmp5_);
	_g_object_unref0 (manager);
}

static void
desktop_folder_clipboard_clipboard_manager_release_pending_files (DesktopFolderClipboardClipboardManager* self)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->files;
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp0_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			DesktopFolderClipboardClipboardFile* _tmp1_;
			DesktopFolderClipboardClipboardFile* file = NULL;
			_tmp1_ = _g_object_ref0 ((DesktopFolderClipboardClipboardFile*) file_it->data);
			file = _tmp1_;
			{
				DesktopFolderClipboardClipboardFile* _tmp2_;
				guint _tmp3_;
				_tmp2_ = file;
				g_signal_parse_name ("on-delete", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_FILE, &_tmp3_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_on_file_destroyed_desktop_folder_clipboard_clipboard_file_on_delete, self);
				_g_object_unref0 (file);
			}
		}
	}
	(self->priv->files == NULL) ? NULL : (self->priv->files = (_g_list_free__g_object_unref0_ (self->priv->files), NULL));
	self->priv->files = NULL;
}

gboolean
desktop_folder_clipboard_clipboard_manager_get_can_paste (DesktopFolderClipboardClipboardManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_paste;
	return result;
}

static void
desktop_folder_clipboard_clipboard_manager_set_can_paste (DesktopFolderClipboardClipboardManager* self,
                                                          gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = desktop_folder_clipboard_clipboard_manager_get_can_paste (self);
	if (old_value != value) {
		self->priv->_can_paste = value;
		g_object_notify_by_pspec ((GObject *) self, desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY]);
	}
}

static void
desktop_folder_clipboard_clipboard_manager_class_init (DesktopFolderClipboardClipboardManagerClass * klass,
                                                       gpointer klass_data)
{
	desktop_folder_clipboard_clipboard_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DesktopFolderClipboardClipboardManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_folder_clipboard_clipboard_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_folder_clipboard_clipboard_manager_set_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_folder_clipboard_clipboard_manager_finalize;
	/** Returns TRUE if the contents of the clipboard can be pasted into a folder.
	        **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY, desktop_folder_clipboard_clipboard_manager_properties[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY] = g_param_spec_boolean ("can-paste", "can-paste", "can-paste", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	desktop_folder_clipboard_clipboard_manager_signals[DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CHANGED_SIGNAL] = g_signal_new ("changed", DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	desktop_folder_clipboard_clipboard_manager_marlin_clipboard_manager_quark = g_quark_from_string ("marlin-clipboard-manager");
	desktop_folder_clipboard_clipboard_manager_x_special_gnome_copied_files = gdk_atom_intern_static_string ("x-special/gnome-copied-files");
}

static void
desktop_folder_clipboard_clipboard_manager_instance_init (DesktopFolderClipboardClipboardManager * self,
                                                          gpointer klass)
{
	self->priv = desktop_folder_clipboard_clipboard_manager_get_instance_private (self);
	self->priv->files = NULL;
	self->priv->files_cutted = FALSE;
	self->priv->_can_paste = FALSE;
}

static void
desktop_folder_clipboard_clipboard_manager_finalize (GObject * obj)
{
	DesktopFolderClipboardClipboardManager * self;
	GtkClipboard* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
	desktop_folder_clipboard_clipboard_manager_release_pending_files (self);
	_tmp0_ = self->priv->clipboard;
	g_signal_parse_name ("owner-change", gtk_clipboard_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _desktop_folder_clipboard_clipboard_manager_owner_changed_gtk_clipboard_owner_change, self);
	_g_object_unref0 (self->priv->clipboard);
	(self->priv->files == NULL) ? NULL : (self->priv->files = (_g_list_free__g_object_unref0_ (self->priv->files), NULL));
	G_OBJECT_CLASS (desktop_folder_clipboard_clipboard_manager_parent_class)->finalize (obj);
}

static GType
desktop_folder_clipboard_clipboard_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopFolderClipboardClipboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_folder_clipboard_clipboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopFolderClipboardClipboardManager), 0, (GInstanceInitFunc) desktop_folder_clipboard_clipboard_manager_instance_init, NULL };
	GType desktop_folder_clipboard_clipboard_manager_type_id;
	desktop_folder_clipboard_clipboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopFolderClipboardClipboardManager", &g_define_type_info, 0);
	DesktopFolderClipboardClipboardManager_private_offset = g_type_add_instance_private (desktop_folder_clipboard_clipboard_manager_type_id, sizeof (DesktopFolderClipboardClipboardManagerPrivate));
	return desktop_folder_clipboard_clipboard_manager_type_id;
}

GType
desktop_folder_clipboard_clipboard_manager_get_type (void)
{
	static volatile gsize desktop_folder_clipboard_clipboard_manager_type_id__once = 0;
	if (g_once_init_enter (&desktop_folder_clipboard_clipboard_manager_type_id__once)) {
		GType desktop_folder_clipboard_clipboard_manager_type_id;
		desktop_folder_clipboard_clipboard_manager_type_id = desktop_folder_clipboard_clipboard_manager_get_type_once ();
		g_once_init_leave (&desktop_folder_clipboard_clipboard_manager_type_id__once, desktop_folder_clipboard_clipboard_manager_type_id);
	}
	return desktop_folder_clipboard_clipboard_manager_type_id__once;
}

static void
_vala_desktop_folder_clipboard_clipboard_manager_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec)
{
	DesktopFolderClipboardClipboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
	switch (property_id) {
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY:
		g_value_set_boolean (value, desktop_folder_clipboard_clipboard_manager_get_can_paste (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_desktop_folder_clipboard_clipboard_manager_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec)
{
	DesktopFolderClipboardClipboardManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_FOLDER_CLIPBOARD_TYPE_CLIPBOARD_MANAGER, DesktopFolderClipboardClipboardManager);
	switch (property_id) {
		case DESKTOP_FOLDER_CLIPBOARD_CLIPBOARD_MANAGER_CAN_PASTE_PROPERTY:
		desktop_folder_clipboard_clipboard_manager_set_can_paste (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

